%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Hw6: classify textures by moments              %
%    Student: Bo Han                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%result: pic2 and pic4 are grouped into one class.
%        pic1, pic3, pic5 and pic6 are grouped into another class, in which
%        pic5 and pic6 may be grouped into a subclass

clear
% read in each image and compute the moment invarients
img=[];
invms=[];
for i=1:6
    tem=sprintf('%1d',i);
    filename=['hw6_' tem '.jpg'];
    img=imread(filename);
    figure;
    imshow(img);
    title(tem);
    %compute the moment invarients for each image
    invms(i,1:7)=abs(log(invmoments(img)));
end

%standarize the vectors
for j=1:7
    tem=invms(:,j);
    stdt=std(tem);
    meant=mean(tem);
    sinvms(:,j)=(tem-meant)./stdt;
end
    
%compare the Euclidean Distance
edist=[];
for i=1:6
    for j=1:6
      edist(i,j) = vectorComp(sinvms(i,:),sinvms(j,:), 2);
  end
end

%compare the Cosine Distance
cosdist=[];
for i=1:6
    for j=1:6
      cosdist(i,j) = vectorComp(sinvms(i,:),sinvms(j,:), 1);
  end
end


